unit MyDBGrid;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Windows, Controls, Graphics, StdCtrls, ExtCtrls,
  Dialogs, DBGrids, Grids;

type
  TMyHackedGrid = class(TDBGrid);
  TMyDBGrid = class(TDBGrid)
  private

  protected

  public
    function GetSelectedRow : Integer;
    function GetVisibleRowCount : Integer;
    procedure ScrollTo(aIndexField : String; aValue : Integer; aOffset : Integer);
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
  published

  end;

procedure Register;

implementation

{$R mydbgrid.res}

constructor TMyDBGrid.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  AlternateColor := clMoneyGreen;
  Color := clCream;
  Options := Options + [dgRowSelect];
  Options := Options - [dgEditing];
  AutoFillColumns := true;
end;

destructor TMyDBGrid.Destroy;
begin
  inherited Destroy;
end;

function TMyDBGrid.GetSelectedRow : Integer;
begin
  Result := TMyHackedGrid(Self).Row;
end;

function TMyDBGrid.GetVisibleRowCount : Integer;
begin
  Result := TMyHackedGrid(Self).VisibleRowCount;
end;

procedure TMyDBGrid.ScrollTo(aIndexField : String; aValue : Integer; aOffset : Integer);
var
  iTemp : Integer;
begin
  if (not Assigned(DataSource)) or
     (DataSource.DataSet.Active = False) or
     (DataSource.DataSet.RecordCount = 0) then
       exit;

  DataSource.DataSet.First;
  DataSource.DataSet.Locate(aIndexField, aValue, []);

  for iTemp := 1 to aOffset do
  begin
    PostMessage(Self.Handle, WM_KEYDOWN, VK_UP, 0);
  end;

  for iTemp := 1 to aOffset do
  begin
    PostMessage(Self.Handle, WM_KEYDOWN, VK_DOWN, 0);
  end;
end;

procedure Register;
begin
  RegisterComponents('Misc',[TMyDBGrid]);
end;

end.
